package cmd

import (
	"fmt"
	"strings"
	"text/template"
)

var tplFuncs = template.FuncMap{
	"map":  tplMap,
	"join": tplJoin,
}

func tplMap(vals ...any) (map[string]any, error) {
	if len(vals)%2 != 0 {
		return nil, fmt.Errorf("missing value, need one key and one value per kv pair")
	}

	m := make(map[string]any)
	for i := 0; i < len(vals); i += 2 {
		m[vals[i].(string)] = vals[i+1]
	}
	return m, nil
}

func tplJoin(strs ...string) string {
	return strings.Join(strs, "")
}
